
{
(1) Last Modify OCT 2 1996 By Tom Lee
(2) modified by Rhodesia Oct 22, 1998
(3)// modified list: Check_ISBN, Check_ISSN, Check_Code
 1998/12/23 Weili Hsieh
  Added SetDMDatabase() to replace problematic AssignDatabase() in many
     dataModules among T2.2 programs.
    IsEnglish() & IsDigit() are modified to avoid compiler warnings.
    Please note that CheckChi() is buggy and we cannot fix it until the entire
     T2.2 has been inspected.
(4) 2000/02/01 Emma קresult 覡

}
unit Comlib;

interface

uses
  Windows, SysUtils, Dialogs, Forms, dbTables, clipbrd, db, graphics, stdctrls,
  grids, FileCtrl, Controls, version, wwdblook, dbctrls, classes;

var
  DB_databasename: string;

function PadLeftZero(value: string): string;
function GetToken(aString, SepChar: string; TokenNum: integer): string;
function NumToken(aString, SepChar: string): integer;
function FixLike(value: string): string;
function ReadINI(FileName, Section, Item: string): string;
function CheckChi(ChkStr: string): Boolean;
function get_cp(inp: string; var st_cp: integer; var lst_cp: integer): Boolean;
function IsDigit(inp: string): Boolean;
function IsEnglish(inp: string): Boolean;
function GetTDSPacketSize(item: string): string;
function GetInsDupErrCode(Item: string): Integer;
function check_ISBN(Org_str: string; var ISBN: string): Boolean;
function check_ISSN(Org_str: string; var ISSN: string): Boolean;
function Check_Number(Decode_ST: string): string;
function Check_Code(S: string): Boolean;
function Insert_Set(St1, St2: string; St_Pos: Integer): string;
procedure GetCodePage(var CodePage: Integer);
procedure WriteINI(FileName, Section, Item, Value: string);
procedure SetDMDatabase(dm: TDataModule; db: TDataBase);

function MyReadINI(FileName, Section, Item: string): string;
procedure MyWriteINI(FileName, Section, Item, Value: string);
procedure MyClearINI(FileName, Section, Item: string);

// 20060428 add by wya for debug begin
function ShowSQLAndSetClipbordMessage(In_Query: TQuery): boolean;
function ShowAndSetClipbordMessage(In_str: string): boolean;
function BooleanToString(In_Param: Boolean): string;
function ShowDatasetAndSetClipbordMessage(In_Dataset: TDataSet; delimeter: string): boolean;
//    function ShowDatasetAndSetClipbordMessage(In_Dataset:TDataSet):boolean;
function ShowTableAndSetClipbordMessage(In_Tablename, In_databasename, delimeter: string): boolean;
// 20060428 add by wya for debug end
function IsAllSingleByte(In_str: string): boolean;
function GetSQLAndSetClipbordMessage(In_Query: TQuery; bShow: boolean): AnsiString;
function StringArrayToString(In_Arr: array of string): string;
function ShowCurrentDatasetAndSetClipbordMessage(In_Dataset: TDataSet; delimeter: string): boolean;
function GetCurrentDataset(In_Dataset: TDataSet; delimeter: string): string;
function GetBitValue(Data: Byte; Index: Byte): Byte;
function GetIntegerBitValue(Data2: Integer; Index: Byte): Byte;
function GetIntBitString(Data2: Integer): string;
function String_Wrap_Width(In_Str: string; In_width: integer; In_font: TFont): string;
function String_Wrap_Height(In_Str: string; In_width: integer; In_font: TFont): integer;
function String_Width(In_Str: string; In_font: TFont): integer;
function GetDatasetAndSetClipbordMessage(In_Dataset: TDataSet; delimeter: string): string;
function ReplaceFromString(In_Str, search_str, rep_str: string): string;
function SetClipbordMessage(In_str: string): boolean;
function ShowMessageDlgAndSetClipbordMessage(In_str: string): boolean;
function GetStringgridAndSetClipbordMessage(In_Stringgrid: TStringGrid; delimeter: string): string;
function funWriteINI(FileName, Section, Item, Value: string): boolean;
function BooleanTo01(In_Param: Boolean): byte;
function TrimAll(In_Param: string): string;
function DateToStr2(in_date: TDate): string;
function DateToJul(in_date: TDate): integer;
function IsLeapYear(Year: word): Boolean;
function DaysThisMonth(Month: byte; Year: word): byte;
function IsValidDate(In_Date: string): Boolean;
function ToValidDate(In_Date: string): string;
function TimeToStr2(in_datetime: TDateTime): string;
function get_Field_Value(in_field: TField): AnsiString;
function StrToHexStr(In_Str: AnsiString): AnsiString;
function set_Databases_Params_APPLICATIONNAME(In_Filename, In_UserID, In_UserName: string): string;
function getVersionInfo(In_File: string): string;
procedure SetFormComboBoxDropDownCount(In_frm: TForm; In_DropDownCount: word);
function getClipbordMessage: AnsiString;
function DateTimeToStr2(in_datetime: TDateTime): string;
procedure Correct_xlssheet_Name(var In_Name: string);
procedure rename_xlssheet(In_Name: string; var MsExcelWorkSheet: Variant);
procedure addxlssheet(onlyrename: boolean; current: Integer; var recordbegin: Integer;
  MsExcelWorkBook: Variant; var MsExcelWorkSheet: Variant);
procedure addxlsSQLsheet(showSQLStr: Boolean; In_DataSet: TDataSet; RecordPerSheet: word;
  SVR_Name: string; MsExcelWorkBook: Variant; var MsExcelWorkSheet: Variant; var row: Integer);
procedure writexlsFieldName(In_FieldDesc: string; In_DataSet: TDataSet;
  var MsExcelWorkSheet: Variant; var row: Integer);
procedure set_Excel_Value_From_Field(In_Excel: Variant; In_Row: word; In_Col: byte;
  in_field: TField; shownull: boolean);
function is_Field_Type_Numeric(in_field: TField): boolean;
function is_Field_Value_Numeric(in_field: TField): boolean;
function is_Field_Value_Date(in_field: TField): boolean;
procedure set_Excel_WrapText(In_Excel: Variant; In_Row: word; In_Col: byte;
  In_TrueFalse: boolean);
function ByteToExcelCol(in_Byte: Byte): string; //q1_:1->A,2->B...

implementation

function ByteToExcelCol(in_Byte: Byte): string; //q1_:1->A,2->B...
begin
  result := '';
  if (in_Byte > 26) then
    begin
      if (in_Byte mod 26 = 0) then
        Result := Result + Chr(in_Byte div 26 - 1 + 64)
      else
        Result := Result + Chr(in_Byte div 26 + 64);
    end;
  Result := Result + chr((in_Byte - 1) mod 26 + 1 + 64);
end;

procedure set_Excel_WrapText(In_Excel: Variant; In_Row: word; In_Col: byte;
  In_TrueFalse: boolean);
var
  max_col, max_row: word;
begin
  max_col := In_Excel.UsedRange.columns.count;
  max_row := In_Excel.UsedRange.rows.count;
  if (In_Row > max_row - 1) then exit;
  if (In_Col > max_col - 1) then exit;
  try
    if (In_Row = 0) and (In_Col = 0) then
      begin
        In_Row := max_row; In_Col := max_col;
        In_Excel.Range['A1:' + ByteToExcelCol(In_Col) + IntToStr(In_Row)].WrapText := In_TrueFalse;
      end
    else
      In_Excel.Range[ByteToExcelCol(In_Col) + IntToStr(In_Row)].WrapText := In_TrueFalse;
  except
  end;
end;

function is_Field_Value_Date(in_field: TField): boolean;
begin
  Result := true;
  try
    StrToDateTime(get_Field_Value(in_field));
  except
    Result := false;
  end;
end;

function is_Field_Value_Numeric(in_field: TField): boolean;
begin
  Result := true;
  try
    StrToFloat(get_Field_Value(in_field));
  except
    Result := false;
  end;
end;

function is_Field_Type_Numeric(in_field: TField): boolean;
begin
  Result := (in_field.DataType in [ftSmallint, ftInteger, ftWord, ftFloat, ftBCD, ftCurrency]);
end;

procedure set_Excel_Value_From_Field(In_Excel: Variant; In_Row: word; In_Col: byte;
  in_field: TField; shownull: boolean);
begin
  try
    if in_field.IsNull and not shownull then
      In_Excel.cells[In_Row, In_Col] := ''
    else
      begin
        if not is_Field_Type_Numeric(in_field) then
          In_Excel.cells[In_Row, In_Col].NumberFormat := '@';
        In_Excel.cells[In_Row, In_Col] := get_Field_Value(in_field);
      end;
  except
  end;
end;

procedure writexlsFieldName(In_FieldDesc: string; In_DataSet: TDataSet;
  var MsExcelWorkSheet: Variant; var row: Integer);
var
  lcl_col: byte; tmp_FieldDesc_List: TStringList; max_cnt: Smallint;
begin
  tmp_FieldDesc_List := TStringList.Create;
  try
    if (Trim(In_FieldDesc) <> '') then tmp_FieldDesc_List.Text := In_FieldDesc;
    max_cnt := In_DataSet.FieldCount;
    if (tmp_FieldDesc_List.Count > max_cnt) then max_cnt := tmp_FieldDesc_List.Count;
    for lcl_col := 1 to max_cnt do
      if (tmp_FieldDesc_List.Count >= lcl_col) and (tmp_FieldDesc_List.Strings[lcl_col - 1] <> '') then
        MsExcelWorkSheet.cells[row, lcl_col] := tmp_FieldDesc_List.Strings[lcl_col - 1]
      else if (In_DataSet.FieldCount >= lcl_col) then
        MsExcelWorkSheet.cells[row, lcl_col] := In_DataSet.Fields[lcl_col - 1].FieldName;
  finally
    tmp_FieldDesc_List.Free; tmp_FieldDesc_List := nil;
  end;
end;

procedure addxlsSQLsheet(showSQLStr: Boolean; In_DataSet: TDataSet; RecordPerSheet: word;
  SVR_Name: string; MsExcelWorkBook: Variant; var MsExcelWorkSheet: Variant; var row: Integer);
var
  tmp_str: string; tmp_strlist: TStringList; wk_ind: byte;
begin
  if (MsExcelWorkSheet.UsedRange.columns.count > 1)
    or (MsExcelWorkSheet.UsedRange.rows.count > 1) then
    begin
      MsExcelWorkBook.sheets.add(count := 1, before := MsExcelWorkBook.sheets[1]);
      MsExcelWorkSheet := MsExcelWorkBook.ActiveSheet;
    end;
  if not showSQLStr then exit;
  tmp_strlist := TStringList.Create;
  tmp_strlist.Text := GetSQLAndSetClipbordMessage(TQuery(In_DataSet), false);
  if (In_DataSet.RecordCount > RecordPerSheet) then
    begin
      tmp_str := 'SQL_String';
      while (tmp_str <> MsExcelWorkSheet.name) do
        try
          MsExcelWorkSheet.name := tmp_str;
        except
          tmp_str := DateTimeToStr2(Now) + tmp_str; Correct_xlssheet_Name(tmp_str);
        end;
      MsExcelWorkSheet.cells[1, 1] := 'SVR_Name=[' + SVR_Name + ']';
      for wk_ind := 0 to tmp_strlist.Count - 1 do
        MsExcelWorkSheet.cells[wk_ind + 2, 1] := tmp_strlist.Strings[wk_ind];
      MsExcelWorkBook.sheets.add(count := 1, before := MsExcelWorkBook.sheets[1]);
      MsExcelWorkSheet := MsExcelWorkBook.ActiveSheet;
    end
  else
    begin
      MsExcelWorkSheet.cells[row, 1] := 'SVR_Name=[' + SVR_Name + ']';
      inc(row);
      for wk_ind := 0 to tmp_strlist.Count - 1 do
        begin
          MsExcelWorkSheet.cells[row, 1].NumberFormat := '@';
          MsExcelWorkSheet.cells[row, 1] := tmp_strlist.Strings[wk_ind];
          inc(row);
        end;
    end;
  tmp_strlist.Free; tmp_strlist := nil;
end;

procedure addxlssheet(onlyrename: boolean; current: Integer; var recordbegin: Integer;
  MsExcelWorkBook: Variant; var MsExcelWorkSheet: Variant);
begin
  if (current > 0) then
    rename_xlssheet(MsExcelWorkSheet.name + ' - ' + inttostr(current), MsExcelWorkSheet);
  if onlyrename then exit;
  MsExcelWorkBook.sheets.add(count := 1, before := MsExcelWorkBook.sheets[1]);
  MsExcelWorkSheet := MsExcelWorkBook.ActiveSheet;
  recordbegin := current + 1;
  MsExcelWorkSheet.name := 'Rcd#' + inttostr(recordbegin);
end;

procedure rename_xlssheet(In_Name: string; var MsExcelWorkSheet: Variant);
begin
  while (In_Name <> MsExcelWorkSheet.name) do
    try
      MsExcelWorkSheet.name := In_Name;
    except
      In_Name := copy(TimeToStr2(Now), 1, 8) + In_Name; Correct_xlssheet_Name(In_Name);
    end;
end;

procedure Correct_xlssheet_Name(var In_Name: string);
var
  debug_str: string;
begin
  debug_str := In_Name;
  if (pos(':', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, ':', '');
  if (pos('/', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, '/', '');
  if (pos('\', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, '\', '');
  if (pos('?', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, '?', '');
  if (pos('*', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, '*', '');
  if (pos('[', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, '[', '');
  if (pos(']', In_Name) > 0) then In_Name := ReplaceFromString(In_Name, ']', '');
  if (Length(In_Name) > 31) then In_Name := copy(In_Name, 1, 31);
end;

function DateTimeToStr2(in_datetime: TDateTime): string;
var
  tmp_str: string; tmp_timestamp: TTimeStamp;
begin
  tmp_timestamp := DateTimeToTimeStamp(in_datetime); Result := '';
  tmp_str := datetostr2(in_datetime);
  if ((tmp_timestamp.Date > 693596) or (tmp_timestamp.Time = 0))
    and (tmp_str <> '') then Result := tmp_str;
  tmp_str := timetostr2(in_datetime);
  if (Result <> '') and (tmp_timestamp.Time > 0) then Result := Result + ' ';
  if (tmp_timestamp.Time > 0) and (tmp_str <> '') then Result := Result + tmp_str;
end;

function getClipbordMessage: AnsiString;
begin
  Result := ''; Clipboard.Open;
  try
    try
      result := Clipboard.AsText;
    except
    end;
  finally
    Clipboard.Close;
  end;
end;

procedure SetFormComboBoxDropDownCount(In_frm: TForm; In_DropDownCount: word);
var
  i: Word;
begin
  with In_frm do
    for i := 0 to ComponentCount - 1 do
      begin
        if (Components[i].InheritsFrom(TComboBox)) then TComboBox(Components[i]).DropDownCount := In_DropDownCount;
        if (Components[i].InheritsFrom(TwwDBLookupCombo)) then TwwDBLookupCombo(Components[i]).DropDownCount := In_DropDownCount;
        if (Components[i].InheritsFrom(TDBComboBox)) then TDBComboBox(Components[i]).DropDownCount := In_DropDownCount;
        if (Components[i].InheritsFrom(TDBLookupComboBox)) then TDBLookupComboBox(Components[i]).DropDownRows := In_DropDownCount;
        if (Components[i].InheritsFrom(TwwDBLookupCombo)) then TwwDBLookupCombo(Components[i]).DropDownCount := In_DropDownCount;
      end;
end;

function getVersionInfo(In_File: string): string;
var
  tmp_ver: TVersionResource;
begin
  Result := '';
  tmp_ver := TVersionResource.Create(nil); tmp_ver.FileName := In_File;
  Result := tmp_ver.VersionInfo.ProductVersion;
  tmp_ver.Free; tmp_ver := nil;
end;

function set_Databases_Params_APPLICATIONNAME(In_Filename, In_UserID, In_UserName: string): string;
begin
  Result := getVersionInfo(In_Filename) + ' ' + In_UserID + ' ' + In_UserName;
  while (pos('.', Result) > 0) do
    Result := copy(Result, pos('.', Result) + 1, length(Result));
  Result := copy(In_Filename, 1, pos('.', In_Filename) - 1) + ' ' + Result;
  while (pos('\', Result) > 0) do
    Result := copy(Result, pos('\', Result) + 1, length(Result));
  Result := ReplaceFromString(Result, '  ', ' ');
  if Length(Result) > 30 then Result := copy(Result, 1, 30);
end;

function StrToHexStr(In_Str: AnsiString): AnsiString;
var
  bt: byte;
  l_ind: Integer;
  l_str: AnsiString;
begin
  l_str := '';
  for l_ind := 1 to Length(In_Str) do
    begin
      bt := ord(In_Str[l_ind]);
      l_str := l_str + inttohex(bt div 16, 1) + inttohex(bt mod 16, 1);
    end;
  Result := l_str;
end;

function get_Field_Value(in_field: TField): AnsiString;
var
  tmp_str: string; tmp_pos_date, tmp_pos_time: byte;
begin
  if (in_field.IsNull) then
    Result := 'null'
  else
    case in_field.DataType of
      ftdate, fttime, ftdatetime:
        begin
          tmp_str := in_field.AsString;
          tmp_pos_date := pos('/', tmp_str);
          tmp_pos_time := pos(':', tmp_str);
          if (tmp_pos_date > 0) and (tmp_pos_time > 0) then
            Result := formatdatetime('yyyy/mm/dd hh:mm:ss', in_field.Asdatetime)
          else
            begin
              if (tmp_pos_date = 0) and (tmp_pos_time > 0) then
                Result := formatdatetime('hh:mm:ss', in_field.Asdatetime)
              else
                begin
                  if (tmp_pos_date > 0) and (tmp_pos_time = 0) then
                    Result := formatdatetime('yyyy/mm/dd', in_field.Asdatetime)
                  else
                    Result := tmp_str
                end;
            end;
{20061201 by wya for debug
          ShowAndSetClipbordMessage(
            'in_field.AsString=' + in_field.AsString + #13#10
            + 'Result=' + Result + #13#10
            );
20061201 by wya for debug}
        end;
      ftBoolean: Result := inttostr(BooleanTo01(in_field.asboolean));
      ftBlob: Result := '0x' + StrToHexStr(in_field.asstring);
      else
        Result := in_field.AsString;
    end;
{20061201 by wya for debug
  Result := 'tmp_str=' + tmp_str
    + ' tmp_pos_date=' + inttostr(tmp_pos_date)
    + ' tmp_pos_time=' + inttostr(tmp_pos_time)
    + ' --> ' + Result;
20061201 by wya for debug}
end;

function TimeToStr2(in_datetime: TDateTime): string;
var
  H, M, S, T: word;
begin
  DecodeTime(in_datetime, H, M, S, T);
  Result := Format('%.2d:%.2d:%.2d', [H, M, S]);
{20061201 by wya for debug
  ShowAndSetClipbordMessage(
    'in_datetime=' + TimeToStr(in_datetime) + #13#10
    + 'H=' + inttostr(H) + #13#10
    + 'M=' + inttostr(M) + #13#10
    + 'S=' + inttostr(S) + #13#10
    + 'Result=' + Result + #13#10
    );
20061201 by wya for debug}
//  Result := IntToStr(H) + ':' + IntToStr(M) + ':' + IntToStr(S);
end;

function ToValidDate(In_Date: string): string;
begin
  Result := In_Date;
  if (pos('/', In_Date) = 0) then
    Result := copy(In_Date, 1, length(In_Date) - 4) + '/'
      + copy(In_Date, length(In_Date) - 3, 2) + '/' + copy(In_Date, length(In_Date) - 1, 2);
end;

function IsValidDate(In_Date: string): Boolean;
var
  tmp_date: TDateTime;
begin
  try
    tmp_date := StrToDate(In_Date);
  except
    result := false;
  end;
end;

function IsLeapYear(Year: word): Boolean;
begin
  Result := (Year mod 4 = 0) { years divisible by 4 are... }
  and ((Year mod 100 <> 0) { ...except century years... }
    or (Year mod 400 = 0)); { ...unless it's divisible by 400 }
end;

function DaysThisMonth(Month: byte; Year: word): byte;
const
  DaysPerMonth: array[1..12] of Integer = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31); { usual numbers of days }
begin
  if not ((Month >= 1) and (Month <= 12)) then
    Result := 0 { 0 indicates invalid month, so no days }
  else
    begin
      Result := DaysPerMonth[Month]; { normally, just return number }
      if (Month = 2) and IsLeapYear(Year) then Inc(Result); { plus 1 in leap February }
    end;
end;

function DateToJul(in_date: TDate): integer;
var
  yy, mm, dd, y400, y4, y100, yday, ind: word; jul: integer;
begin
  DecodeDate(in_date, yy, mm, dd);
  y400 := (yy - 1) div 400;
  yday := (yy - 1) mod 400;
  y4 := yday div 4;
  y100 := yday div 100;
  jul := 1721425 + y400 * 146097 + yday * 365 + y4 - y100 + dd;
{20061126 by wya for debug
  ShowAndSetClipbordMessage(
    'in_date=' + DateToStr2(in_date) + #13#10
    + 'yy=' + IntToStr(yy) + #13#10
    + 'mm=' + IntToStr(mm) + #13#10
    + 'dd=' + IntToStr(dd) + #13#10
    + 'y400=' + IntToStr(y400) + #13#10
    + 'y4=' + IntToStr(y4) + #13#10
    + 'y100=' + IntToStr(y100) + #13#10
    + 'yday=' + IntToStr(yday) + #13#10
    + 'jul=' + IntToStr(jul) + #13#10
    );
20061126 by wya for debug}
  for ind := 1 to mm - 1 do
    jul := jul + DaysThisMonth(ind, yy);
{20061126 by wya for debug
  ShowAndSetClipbordMessage(
    'in_date=' + DateToStr2(in_date) + #13#10
    + 'jul=' + IntToStr(jul) + #13#10
    );
20061126 by wya for debug}
  result := jul;
end;

//proITRI 20060428 by wya add begin

function DateToStr2(in_date: TDate): string;
var
  y, mm, d: word;
begin
  DecodeDate(in_date, y, mm, d);
  result := Format('%.4d/%.2d/%.2d', [y, mm, d]);
end;

function TrimAll(In_Param: string): string;
var
  tmp_ind: integer;
begin
  result := '';
  for tmp_ind := 1 to Length(In_Param) do
    begin
      if In_Param[tmp_ind] <> #32 then result := result + In_Param[tmp_ind];
    end;
{20061110 by wya for debug
  ShowAndSetClipbordMessage(
    'In_Param=' + In_Param + #13#10
    + 'result=' + result + #13#10
    );
20061110 by wya for debug}
end;

function BooleanTo01(In_Param: Boolean): byte;
begin
  if In_Param then
    result := 1
  else
    result := 0;
end;

function funWriteINI(FileName, Section, Item, Value: string): boolean;
begin
  result := WritePrivateProfileString(PChar(Section), PChar(Item), PChar(Value), PChar(FileName));
end;

function GetStringgridAndSetClipbordMessage(In_Stringgrid: TStringGrid; delimeter: string): string;
var
  In_str: string; wk_rcdcnt, wk_index: byte;
begin
  In_str := In_Stringgrid.Name + ': RowCount=' + inttostr(In_Stringgrid.RowCount)
    + ' ColCount=' + inttostr(In_Stringgrid.ColCount);
  with In_Stringgrid do
    begin
      wk_rcdcnt := 0;
      while (wk_rcdcnt < RowCount) do
        begin
          In_str := In_str + #13#10;
          for wk_index := 0 to ColCount - 1 do
            begin
              In_str := In_str + Cells[wk_index, wk_rcdcnt] + delimeter;
            end;
          if wk_rcdcnt > 500 then
            begin
              In_str := In_str + #13#10 + '==>٦h...';
              Break;
            end;
          inc(wk_rcdcnt);
        end;
    end;
  result := In_str;
end;

function ShowMessageDlgAndSetClipbordMessage(In_str: string): boolean;
begin
  Clipboard.Open;
  try
    try
      Clipboard.SetTextBuf(pchar(in_str));
      result := true;
      if Clipboard.AsText <> In_str then Result := false;
    except
      result := false;
    end;
  finally
    Clipboard.Close;
  end;
//  ShowMessage(In_str);
  if (MessageDlg(In_str, mtConfirmation, [mbOK, mbCancel], 0) = mrCancel) then Result := false;
end;

function SetClipbordMessage(In_str: string): boolean;
begin
  Clipboard.Open;
  try
    try
      Clipboard.SetTextBuf(pchar(in_str));
      result := true;
      if Clipboard.AsText <> In_str then Result := false;
    except
      result := false;
    end;
  finally
    Clipboard.Close;
  end;
end;

function ReplaceFromString(In_Str, search_str, rep_str: string): string;
var
  lc_ind: integer;
begin
  lc_ind := Pos(search_str, In_Str);
  while (lc_ind > 0) do
    begin
      In_Str := copy(in_str, 1, lc_ind - 1) + rep_str + copy(in_str, lc_ind + length(search_str), length(in_str));
      lc_ind := Pos(search_str, In_Str);
    end;
  Result := In_Str;
end;

function GetDatasetAndSetClipbordMessage(In_Dataset: TDataSet; delimeter: string): string;
var
  In_str: string; wk_rcdcnt, wk_index: byte;
begin
  In_str := In_Dataset.Name + ': Total Records=' + inttostr(In_Dataset.RecordCount);
  with In_Dataset do
    begin
      In_str := In_str + #13 + #10 + 'Rcd#' + delimeter;
      for wk_index := 0 to fieldcount - 1 do
        begin
          In_str := In_str + Fields[wk_index].fieldname + delimeter;
        end;
      First;
      wk_rcdcnt := 0;
      while not eof do
        begin
          inc(wk_rcdcnt);
          In_str := In_str + #13 + #10 + inttostr(wk_rcdcnt) + delimeter;
          for wk_index := 0 to fieldcount - 1 do
            begin
//              In_str := In_str + Fields[wk_index].asstring + delimeter;
              In_str := In_str + get_Field_Value(Fields[wk_index]) + delimeter;
            end;
          if wk_rcdcnt > 100 then
            begin
              In_str := In_str + #13#10 + '==>٦h...';
              Break;
            end;
          next;
        end;
      First;
    end;
  result := In_str;
end;

function String_Width(In_Str: string; In_font: TFont): integer;
var
  tmp_label: TLabel;
begin
  tmp_label := TLabel.Create(Application);
  tmp_label.Caption := In_Str;
  tmp_label.Font := In_font;
  Result := tmp_label.Width * 11 div 10;
  tmp_label.Free;
end;

function String_Wrap_Height(In_Str: string; In_width: integer; In_font: TFont): integer;
var
  Memo1: TMemo;
begin
  Memo1 := TMemo.Create(Application);
  Memo1.Parent := Application.MainForm;
  Memo1.Width := In_width;
  Memo1.Font.Assign(In_font);
  Memo1.Lines.Add(trim(In_Str));
//  Result := In_font.Size * Memo1.Lines.Count;
//  Result := (In_font.Size * In_font.PixelsPerInch div 72) * Memo1.Lines.Count;
  if true then
    Result := In_font.Height * Memo1.Lines.Count * 11 div 10
  else
    if (Memo1.Lines.Count > 2) then
      Result := (In_font.Size * In_font.PixelsPerInch * 100 * Memo1.Lines.Count) div 9600
    else
      Result := (In_font.Size * In_font.PixelsPerInch * 100 * Memo1.Lines.Count) div 8400;
  Memo1.Free;
end;

function String_Wrap_Width(In_Str: string; In_width: integer; In_font: TFont): string;
var
  wk_str: string;
  charsperrow: byte;
  wk_Index: integer;
begin
  wk_str := '';
  charsperrow := (In_width * 2) div (In_font.Size);
  wk_Index := 0;
  while (wk_Index <= Length(In_Str)) do
    begin
      if (Length(wk_str) > 0) then wk_str := wk_str + #13#10;
      wk_str := wk_str + copy(In_Str, wk_Index, charsperrow);
      wk_Index := wk_Index + charsperrow;
    end;
  Result := wk_str;
end;

function GetIntBitString(Data2: Integer): string;
var
  wk_index: byte; wk_str: string;
begin
  wk_str := '';
  for wk_index := 16 downto 1 do
    wk_str := wk_str + inttostr(GetIntegerBitValue(data2, wk_index));
  result := wk_str;
end;

function GetIntegerBitValue(Data2: Integer; Index: Byte): Byte;
begin
  if index > 16 then
    result := getIntegerbitvalue(hi(data2), index - 8)
  else
    if index > 8 then
      begin
        result := getbitvalue(hi(data2), index - 8);
      end
    else
      begin
        result := getbitvalue(lo(data2), index);
      end;
end;

function GetBitValue(Data: Byte; Index: Byte): Byte;
{
var
  Bits: array[0..7] of Byte absolute Data;
}
begin
  Dec(Index);
  if ((data shr (index mod 8)) mod 2) = 1 then
    result := 1
  else
    result := 0;
{
  if Bits[Index div 8] and (128 shr (Index mod 8)) > 0 then
    result := 1
  else
    result := 0;
}
end;

function GetCurrentDataset(In_Dataset: TDataSet; delimeter: string): string;
var
  In_str: string; wk_index: byte;
begin
  In_str := In_Dataset.Name + ': Total Records=' + inttostr(In_Dataset.RecordCount);
  with In_Dataset do
    begin
      In_str := In_str + #13#10;
      for wk_index := 0 to fieldcount - 1 do
        begin
          In_str := In_str + Fields[wk_index].fieldname + delimeter;
        end;
      In_str := In_str + #13#10;
      for wk_index := 0 to fieldcount - 1 do
        begin
//          In_str := In_str + Fields[wk_index].asstring + delimeter;
          In_str := In_str + get_Field_Value(Fields[wk_index]) + delimeter;
        end;
      In_str := In_str + #13#10;
    end;
  result := In_str;
end;

function ShowCurrentDatasetAndSetClipbordMessage(In_Dataset: TDataSet; delimeter: string): boolean;
var
  In_str: string; wk_index: byte;
begin
  Clipboard.Open;
  try
    try
      In_str := In_Dataset.Name + ': Total Records=' + inttostr(In_Dataset.RecordCount);
      with In_Dataset do
        begin
          In_str := In_str + #13#10;
          for wk_index := 0 to fieldcount - 1 do
            begin
              In_str := In_str + Fields[wk_index].fieldname + delimeter;
            end;
          In_str := In_str + #13#10;
          for wk_index := 0 to fieldcount - 1 do
            begin
              In_str := In_str + get_Field_Value(Fields[wk_index]) + delimeter;
            end;
        end;
      Clipboard.SetTextBuf(pchar(in_str));
      result := true;
      if Clipboard.AsText <> In_str then Result := false;
    except
      result := false;
    end;
  finally
    Clipboard.Close;
  end;
  ShowMessage(In_str);
//  MessageDlg(In_str,mtInformation,[mbOK],0);
end;

function StringArrayToString(In_Arr: array of string): string;
var
  wk_index: integer; wk_str: string;
begin
  wk_str := '';
  for wk_index := 0 to High(In_Arr) do
    if not (In_Arr[wk_index] = '') then
      begin
        if not (wk_str = '') then wk_str := wk_str + #13#10;
        wk_str := wk_str + In_Arr[wk_index];
      end;
  result := wk_str;
end;

function GetSQLAndSetClipbordMessage(In_Query: TQuery; bShow: boolean): AnsiString;
var
  In_str: string; wk_index: byte;
begin
  Clipboard.Open;
  try
    In_str := In_Query.Name + '.SQL.Text:' + In_Query.SQL.Text + #13 + #10;
    if In_Query.ParamCount > 0 then
      for wk_index := 0 to In_Query.ParamCount - 1 do
        In_str := In_str + 'Parambyname(''' + In_Query.Params[wk_index].name + ''').asstring:' + In_Query.Params[wk_index].asstring + #13 + #10;
    if In_Query.RowsAffected <> -1 then
      In_str := In_str + 'RowsAffected=' + IntToStr(In_Query.RowsAffected) + #13 + #10;
    Clipboard.SetTextBuf(pchar(in_str));
  finally
    Clipboard.Close;
  end;
  result := In_str;
  if bShow then ShowMessage(In_str);
end;

// 20060505 add by wya
function IsAllSingleByte(In_str: string): boolean;
var
  wk_index: integer;
begin
  for wk_index := 1 to Length(In_str) do
    if IsDBCSLeadByte(byte(in_str[wk_index])) then
      begin
        result := false;
        exit;
      end;
  result := true;
end;
// 20060428 add by wya for debug begin

function ShowTableAndSetClipbordMessage(In_Tablename, In_databasename, delimeter: string): boolean;
var
  tmp_table_qry: TQuery;
  In_str: string; wk_rcdcnt, wk_index: byte;
begin
  with tmp_table_qry do
    begin
      tmp_table_qry := TQuery.Create(nil);
      DatabaseName := In_databasename;
      close;
      sql.Clear;
      SQL.Add('select * from ' + In_Tablename);
      try
        open;
      except
      end;
      Clipboard.Open;
      try
        try
          with tmp_table_qry do
            begin
              In_str := 'Table name:' + In_Tablename + ' Total Records=' + inttostr(RecordCount);
              In_str := In_str + #13 + #10 + 'Rcd#' + delimeter;
              for wk_index := 0 to fieldcount - 1 do
                begin
                  In_str := In_str + Fields[wk_index].fieldname + delimeter;
                end;
              First;
              wk_rcdcnt := 0;
              while not eof do
                begin
                  inc(wk_rcdcnt);
                  In_str := In_str + #13 + #10 + inttostr(wk_rcdcnt) + delimeter;
                  for wk_index := 0 to fieldcount - 1 do
                    begin
                      In_str := In_str + get_Field_Value(Fields[wk_index]) + delimeter;
                    end;
                  if wk_rcdcnt > 100 then
                    begin
                      In_str := In_str + #13#10 + '==>٦h...';
                      Break;
                    end;
                  next;
                end;
            end;
          Clipboard.SetTextBuf(pchar(in_str));
          result := true;
          if Clipboard.AsText <> In_str then Result := false;
        except
          result := false;
        end;
      finally
        Clipboard.Close;
      end;
      ShowMessage(In_str);
      close;
      tmp_table_qry := nil;
    end;
end;
{
function ShowDatasetAndSetClipbordMessage(In_Dataset:TDataSet):boolean;
begin
  ShowDatasetAndSetClipbordMessage(In_Dataset,'|');
end;
}

function ShowDatasetAndSetClipbordMessage(In_Dataset: TDataSet; delimeter: string): boolean;
var
  In_str: string; wk_rcdcnt, wk_index: byte;
begin
  Clipboard.Open;
  try
    try
      In_str := In_Dataset.Name + ': Total Records=' + inttostr(In_Dataset.RecordCount);
      with In_Dataset do
        begin
          In_str := In_str + #13 + #10 + 'Rcd#' + delimeter;
          for wk_index := 0 to fieldcount - 1 do
            begin
              In_str := In_str + Fields[wk_index].fieldname + delimeter;
            end;
          First;
          wk_rcdcnt := 0;
          while not eof do
            begin
              inc(wk_rcdcnt);
              In_str := In_str + #13 + #10 + inttostr(wk_rcdcnt) + delimeter;
              for wk_index := 0 to fieldcount - 1 do
                begin
                  In_str := In_str + get_Field_Value(Fields[wk_index]) + delimeter;
                end;
              if wk_rcdcnt > 100 then
                begin
                  In_str := In_str + #13#10 + '==>٦h...';
                  Break;
                end;
              next;
            end;
          First;
        end;
      Clipboard.SetTextBuf(pchar(in_str));
      result := true;
      if Clipboard.AsText <> In_str then Result := false;
    except
      result := false;
    end;
  finally
    Clipboard.Close;
  end;
  ShowMessage(In_str);
//  MessageDlg(In_str,mtInformation,[mbOK],0);
end;

function BooleanToString(In_Param: Boolean): string;
begin
  if In_Param then
    result := 'true'
  else
    result := 'false';
end;

function ShowSQLAndSetClipbordMessage(In_Query: TQuery): boolean;
var
  In_str: string; wk_index: byte;
begin
  Clipboard.Open;
  try
    try
      In_str := In_Query.Name + '.SQL.Text:' + In_Query.SQL.Text + #13 + #10;
      if In_Query.ParamCount > 0 then
        for wk_index := 0 to In_Query.ParamCount - 1 do
          In_str := In_str + 'Parambyname(''' + In_Query.Params[wk_index].name + ''').asstring:' + In_Query.Params[wk_index].asstring + #13 + #10;
      if In_Query.RowsAffected <> -1 then
        In_str := In_str + 'RowsAffected=' + IntToStr(In_Query.RowsAffected) + #13 + #10;
      Clipboard.SetTextBuf(pchar(in_str));
      result := true;
      if Clipboard.AsText <> In_str then Result := false;
    except
      result := false;
    end;
  finally
    Clipboard.Close;
  end;
  ShowMessage(In_str);
//  MessageDlg(In_str,mtInformation,[mbOK],0);
end;

function ShowAndSetClipbordMessage(In_str: string): boolean;
begin
  Clipboard.Open;
  try
    try
      Clipboard.SetTextBuf(pchar(in_str));
      result := true;
      if Clipboard.AsText <> In_str then Result := false;
    except
      result := false;
    end;
  finally
    Clipboard.Close;
  end;
  ShowMessage(In_str);
//  MessageDlg(In_str,mtInformation,[mbOK],0);
end;
// 20060428 add by wya for debug end

function Insert_Set(St1, St2: string; St_Pos: Integer): string;
begin
  St1 := Copy(St1, 1, St_Pos - 1) + St2 + Copy(St1, St_Pos + length(St2), Length(St1) - St_Pos - Length(St2) + 1);
  Insert_Set := St1;
end;

procedure GetCodePage(var CodePage: Integer);
begin
   //Ycodepage0AhlocalcodepageAçP_ثecodepageA
   //YbҤ䴩d򤺡Ah]w1250
  if CodePage = 0 then
    CodePage := GetAcp;
  case CodePage of
    950, 936, 932, 949, 1251, 1253, 1254, 1257, 1252, 1250: CodePage := CodePage;
    else
      CodePage := 1250;
  end;
end;

function GetTDSPacketSize(Item: string): string;
var
  intTDSPacket: integer;
  strTDSPacket: string;
begin
   // Read Sybase TDS Packets Size Configuration and check its rangs
  strTDSPacket := ReadINI(ExtractFilePath(Application.ExeName) + 'TOTALS.INI', 'SYBASE', Item);
  try
    intTDSPacket := StrToInt(strTDSPacket);
    if intTDSPacket > 8192 then intTDSPacket := 8192;
    if intTDSPacket < 512 then intTDSPacket := 512;
  except
    intTDSPacket := 512;
  end;
  strTDSPacket := IntToStr(intTDSPacket);
  Result := strTDSPacket;
end;

function GetInsDupErrCode(Item: string): Integer;
var
  intErrCode: integer;
begin
   // Read Insert Duplicate Errror Code
  intErrCode := StrToInt(ReadINI(ExtractFilePath(Application.ExeName) + 'TOTALS.INI', 'InsDupErrCod', Item));
  Result := intErrCode;
end;

//oISBN
//modified by Rhodesia Oct 22, 1998

function check_ISBN(Org_str: string; var ISBN: string): Boolean;
var
  Org_ISBN, tmp_Str: string;
begin
  if Trim(Org_str) = '' then
    begin
      ISBN := '';
      Result := True;
    end
  else
    begin
      Org_ISBN := UpperCase(GetToken(Org_str, ' ', 1));
      tmp_str := check_Number(copy(Org_ISBN, 1, length(Org_ISBN) - 1));
      ISBN := tmp_str + UpperCase(copy(Org_ISBN, length(Org_ISBN), 1));
      if length(tmp_str) <> 9 then
        Result := False
      else
        Result := Check_Code(ISBN);
    end;
end;

//oISSN
//modified by Rhodesia Oct 22, 1998

function check_ISSN(Org_str: string; var ISSN: string): Boolean;
var
  Org_ISSN, tmp_str: string;
begin
  if Trim(Org_str) = '' then
    begin
      ISSN := '';
      Result := True;
    end
  else
    begin
      Org_ISSN := UpperCase(GetToken(Org_str, ' ', 1));
      tmp_str := check_Number(copy(Org_ISSN, 1, length(Org_ISSN) - 1));
      ISSN := tmp_str + copy(Org_ISSN, length(Org_ISSN), 1);
      if length(tmp_str) <> 7 then
        Result := False
      else
        Result := Check_Code(ISSN);
    end;
end;

//modified by Rhodesia Oct 22, 1998

function Check_Code(S: string): Boolean;
var
  Sum, I, Len: Integer;
  Chk: string;
begin
  Chk := Copy(S, Length(S), 1);
  S := copy(S, 1, Length(S) - 1);
  Len := Length(S);
  Sum := 0;
  for I := 1 to Len do
    Sum := Sum + (I + 1) * StrToInt(S[Len - I + 1]);
  Sum := 11 - Sum mod 11;
  if Sum = 11 then
    Result := Chk = '0'
  else
    if Sum = 10 then
      Result := Chk = 'X'
    else
      Result := IntToStr(Sum) = Chk;
end;

//oѫ᪺r

function GetToken(aString, SepChar: string; TokenNum: integer): string;
var
  Token: string;
  StrLen: integer;
  TNum: integer;
  TEnd: integer;

begin
  StrLen := Length(aString);
  TNum := 1;
  TEnd := StrLen;
  while ((TNum <= TokenNum) and (TEnd <> 0)) do
    begin
      TEnd := Pos(SepChar, aString);
      if TEnd <> 0 then
        begin
          Token := Copy(aString, 1, TEnd - 1);
          Delete(aString, 1, TEnd);
          Inc(TNum);
        end
      else
        begin
          Token := aString;
        end;
    end;
  if TNum >= TokenNum then
    begin
      GetToken := Token;
    end
  else
    begin
      GetToken := '';
    end;
end;

//ˬdO_r
// 2000/02/01 Emma קresult 覡

function CheckChi(ChkStr: string): Boolean;
var
  i: integer;
  leng: integer;
  tmpStr: string;
  tmpByte: Byte;
begin
  Result := False;
  leng := length(ChkStr);
  for i := 1 to leng do
    begin
      tmpStr := copy(chkStr, i, 1);
      tmpByte := Byte(tmpStr[1]);
    // 2000/02/01 Emma קresult 覡
      result := IsDBCSLeadByte(tmpByte);
    //********************
    //if IsDBCSLeadByte(tmpByte) then
    //  Result := True
    //else
    //  Result := False;
    end;
end;

function NumToken(aString, SepChar: string): integer;
{
parameters: aString : the complete string
            SepChar : a single character used as separator
                      between the substrings
result    : the number of substrings
}

var
  RChar: Char;
  StrLen: integer;
  TNum: integer;
  TEnd: integer;

begin
  if SepChar = '#' then
    begin
      RChar := '*'
    end
  else
    begin
      RChar := '#'
    end;
  StrLen := Length(aString);
  TNum := 0;
  TEnd := StrLen;
  while TEnd <> 0 do
    begin
      Inc(TNum);
      TEnd := Pos(SepChar, aString);
      if TEnd <> 0 then
        begin
          aString[TEnd] := RChar;
        end;
    end;
  NumToken := TNum;
end;

procedure WriteINI(FileName, Section, Item, Value: string);
begin
  WritePrivateProfileString(PChar(Section), PChar(Item), PChar(Value), PChar(FileName));
end;

function ReadINI(FileName, Section, Item: string): string;
var
  OutStr: string;
  retStr: Pchar;
begin
  RetStr := StrAlloc(255);
  GetPrivateProfileString(
    PChar(Section),
    PChar(Item),
    PChar('err'),
    RetStr,
    255,
    PChar(FileName));
  OutStr := StrPas(RetStr);
  Result := OutStr;
end;

procedure MyWriteINI(FileName, Section, Item, Value: string);
var
  sString, sStringLast: string;
  sNo: integer;
  sLength: integer;
begin
  MyClearIni(FileName, Section, Item);
  sNo := 1;
  sString := Value;
  sStringLast := Value;
  sLength := Length(sString);
  if sLength > 250 then
    begin
      while sLength > 250 do
        begin
          sStringLast := Copy(sString, 251, sLength - 250);
          sString := Copy(sString, 1, 250);
          WritePrivateProfileString(PChar(Section), PChar(Item + IntToStr(sNo)), PChar('\\\' + sString), PChar(FileName));
          sString := sStringLast;
          sNo := sNo + 1;
          sLength := Length(sString);
        end;
      if sString <> '' then
        begin
          WritePrivateProfileString(PChar(Section), PChar(Item + IntToStr(sNo)), PChar('\\\' + sString), PChar(FileName));
          sNo := sNo + 1;
        end;
    end
  else
    WritePrivateProfileString(PChar(Section), PChar(Item + IntToStr(sNo)), PChar('\\\' + Value), PChar(FileName));
  if sNo = 1 then sNo := sNo + 1;
  sString := ReadINI(FileName, Section, Item + IntToStr(sNo));
  if sString <> 'err' then
    WritePrivateProfileString(PChar(Section), PChar(Item + IntToStr(sNo)), '', PChar(FileName))
end;

function MyReadINI(FileName, Section, Item: string): string;
var
  OutStr: string;
  retStr: Pchar;
  sIn: Boolean;
  sNo: integer;
  sMyResult: string;
  sPos: integer;
begin
  sIn := True;
  sNo := 1;
  sMyResult := '';
  RetStr := StrAlloc(255);
  while sIn do
    begin
      GetPrivateProfileString(
        PChar(Section),
        PChar(Item + IntToStr(sNo)),
        PChar('err'),
        RetStr,
        255,
        PChar(FileName));
      sNo := sNo + 1;
      if StrPas(RetStr) = 'err' then
        sIn := False
      else
        sMyResult := sMyResult + Copy(StrPas(RetStr), 1, 255);
    end;
  //OutStr := StrPas(RetStr);
  //Result := OutStr;
  if sMyResult = '' then
    sMyResult := 'err'
  else
    begin
      sPos := Pos('\\\', sMyResult);
      while sPos <> 0 do
        begin
          sMyResult := Copy(sMyResult, 1, sPos - 1)
            + Copy(sMyResult, sPos + 3, Length(sMyResult) - sPos - 2);
          sPos := Pos('\\\', sMyResult);
        end;
    end;
  Result := sMyResult
end;

function PadLeftZero(value: string): string;
var
  idx: integer;
  outStr: string;
begin
  outStr := '';
  for idx := 1 to Length(value) do
    if value[idx] = chr(32) then
      OutStr := OutStr + '0'
    else
      OutStr := OutStr + value[idx];
  result := OutStr;
end;

//oUνƥ

function get_cp(inp: string; var st_cp: integer; var lst_cp: integer): Boolean;
var
  i: integer;
  tmp_dot: string;
  token_cnt, ft_pos: integer;
begin
  result := false;
  ft_pos := 0;
  token_cnt := NumToken(inp, '.');
  if (token_cnt >= 2) then
    tmp_dot := gettoken(inp, '.', 1)
  else
    tmp_dot := inp;
  i := 1;
  repeat
    if IsDigit(tmp_dot[i]) = False then
      begin
        if (inp[i] = '-') then
          begin
            st_cp := StrToInt(copy(tmp_dot, 1, i - 1));
            ft_pos := i;
          end
        else
          if (ft_pos = 0) then
            begin
              st_cp := StrToInt(copy(tmp_dot, 1, i - 1));
              lst_cp := 0;
              break;
            end
          else
            begin
              lst_cp := StrToInt(copy(tmp_dot, ft_pos + 1, i - (ft_pos + 1)));
              break;
            end;
      end
    else
      if i = length(tmp_dot) then
        begin
          st_cp := StrToInt(tmp_dot);
          lst_cp := 0;
        end;
    i := i + 1;
  until i + 1 = length(tmp_dot);
end;

//ˬdrO_Ʀr

function IsDigit(inp: string): Boolean;
var
  i: integer;
begin
  Result := false;
  if (inp = '') then exit;
  for i := 1 to length(inp) do
    if (inp[i] < #48) or (inp[i] > #57) then exit;
  Result := true;
end;

//ˬdrO_^r

function IsEnglish(inp: string): Boolean;
var
  i: integer;
begin
  Result := false;
  if (inp = '') then exit;
  for i := 1 to length(inp) do
    if ((inp[i] >= #65) and (inp[i] <= #90)) or
      ((inp[i] >= #97) and (inp[i] <= #122)) then
      begin
        Result := true;
        exit;
      end
end;

{function FixLike (value:String):String;  //Ƶ{Jҧ@
var
   ResultStr:String;
   i:Integer;
begin

    If Length(Trim(value)) = 0 Then
        ResultStr := '%'
    Else
    begin
        ResultStr := '';
        For i := 1 To Length(value) do
        begin
            If (copy(value,i,1)='_') Or (Copy(value,i,1)= '[') Then
                ResultStr := ResultStr + '[' + copy(value, i, 1) + ']'
            Else
                ResultStr := ResultStr + copy(value, i, 1);
        end;
    end;
    Result := ResultStr;
end;}

function FixLike(value: string): string; //Ƶ{Jҧ@
var
  ResultStr: string;
  i: Integer;
begin
  if Length(Trim(value)) = 0 then
    ResultStr := '%'
  else
    begin
      ResultStr := '';
      for i := 1 to Length(value) do
        begin
          if (copy(value, i, 1) = '_') or (Copy(value, i, 1) = '[')
            or (Copy(value, i, 1) = '%') or (Copy(value, i, 1) = ']') then
            ResultStr := ResultStr + '[' + copy(value, i, 1) + ']'
          else
            begin
              ResultStr := ResultStr + copy(value, i, 1);
            end;
        end;
    end;
  Result := ResultStr;
end;

//ŪƦrr(دޮɽTwƦr)

function Check_Number(Decode_ST: string): string;
var
  st: string;
  a: Integer;
begin
  st := '';
  for a := 1 to length(Decode_ST) do
    if Decode_ST[a] in ['0'..'9'] then
      st := st + Decode_ST[a];
  Result := st;
end;

procedure SetDMDatabase(dm: TDataModule; db: TDataBase);
var
  i: integer;
begin
  for i := 0 to dm.ComponentCount - 1 do
    begin
      if dm.Components[i] is TTable then
        (dm.Components[i] as TTable).DatabaseName := db.DataBaseName;
      if dm.Components[i] is TQuery then
        (dm.Components[i] as TQuery).DatabaseName := db.DataBaseName;
      if dm.Components[i] is TStoredProc then
        (dm.Components[i] as TStoredProc).DatabaseName := db.DataBaseName;
    end;
end;

procedure MyClearINI(FileName, Section, Item: string);
begin
  WriteIni(FileName, Section, Item + '1', '');
  WriteIni(FileName, Section, Item + '2', '');
end;

end.

